/*
 * FLFT v1.0 by Nuck-TH
 *
 * Based on FLST (Firefox 4+) v1.2.2
 * by Fabian Schneider,
 * which in turn is based on older
 * add-ons by "Gorgias" and "Gozer"
*/

Components.utils.import("resource://gre/modules/Services.jsm");

var EXPORTED_SYMBOLS = ["options_startup", "options_shutdown"];

const addonID = "flft@nuck-th";

var observer = {
    doc: null,
    observe: function(aSubject, aTopic, aData) {
        if (aTopic == "addon-options-displayed" && aData == addonID) {
            doc = aSubject.QueryInterface(Components.interfaces.nsIDOMDocument);

            var chkenabled = doc.getElementById("enabledpref");
            var chktabflip = doc.getElementById("tabflippingpref");
            chkenabled.addEventListener('oninputchanged', this.updateState);
            chktabflip.addEventListener('oninputchanged', this.updateState);

            this.updateState();
        };
        if (aTopic == "addon-options-hidden" && aData == addonID) {
            var chkenabled = doc.getElementById("enabledpref");
            var chktabflip = doc.getElementById("tabflippingpref");
            chkenabled.removeEventListener('oninputchanged', this.updateState);
            chktabflip.removeEventListener('oninputchanged', this.updateState);
        }
    },

    updateState: function() {
        var chkenabled = doc.getElementById("enabledpref");
        var chkflst = doc.getElementById("flstpref");
        var chktabflip = doc.getElementById("tabflippingpref");
        var chkfastflip = doc.getElementById("fastflippingpref");
        var chkenablekey = doc.getElementById("enablekeypref");
        var chkmiddleclick = doc.getElementById("middleclickpref");

        if(!chkenabled.value) {
            chkflst.setAttribute("disabled", true);
            chktabflip.setAttribute("disabled", true);
            chkfastflip.setAttribute("disabled", true);
            chkenablekey.setAttribute("disabled", true);
            chkmiddleclick.setAttribute("disabled", true);
            return;
        } else {
            chkflst.removeAttribute("disabled");
            chktabflip.removeAttribute("disabled");
            chkfastflip.removeAttribute("disabled");
            chkenablekey.removeAttribute("disabled");
            chkmiddleclick.removeAttribute("disabled");
        };

        if (!chktabflip.value)
        {
            chkfastflip.setAttribute("disabled", true);
            chkenablekey.setAttribute("disabled", true);
        } else {
            chkfastflip.removeAttribute("disabled");
            chkenablekey.removeAttribute("disabled");
        };
    }
};

function options_startup() {
    Services.obs.addObserver(observer, "addon-options-displayed", false);
    Services.obs.addObserver(observer, "addon-options-hidden", false);
};

function options_shutdown() {
    Services.obs.removeObserver(observer, "addon-options-displayed", false);
    Services.obs.removeObserver(observer, "addon-options-hidden", false);
};
